#define PROGRAM_TITLE "MATRIX_GL by Alex Zolotov. 2003. Ekaterinburg. Russia"
//#define WIN32_MODE

#ifdef WIN32_MODE 
#include <windows.h>
#endif

#include <stdio.h>   // Always a good idea.
#include <stdlib.h>
#include <time.h>    // For our FPS stats.
#include <GL/gl.h>   // OpenGL itself.
#include <GL/glu.h>  // GLU support library.
#include <GL/glut.h> // GLUT support library.

#ifndef WIN32_MODE
#include <X11/Xlib.h>
//#include <X11/Xresource.h>
//#include <X11/Xos.h>
//#include "screenhack.h"
#endif

// Some global variables.

// Window and texture IDs, window width and height.
int Texture_ID;
int Window_ID;
int Window_Width = 300;
int Window_Height = 300;

// Scene position and rotation speed variables.
float X_Rot   = 0.9f;
float Y_Rot   = 0.0f;
float X_Speed = 0.0f;
float Y_Speed = 0.5f;
float Z_Off   =-89.0f;

// Settings for our light.  Try playing with these (or add more lights).
float Light_Ambient[]=  { 0.1f, 0.1f, 0.1f, 1.0f };
float Light_Diffuse[]=  { 1.2f, 1.2f, 1.2f, 1.0f }; 
float Light_Position[]= { 2.0f, 2.0f, 0.0f, 1.0f };

//unsigned char font[8][131072]; //8 textures with different lightness
#include "matrix1.h"
unsigned char flare[16]={  0,  0,  0,  0,
                           0,180,  0,  0,
			   0,  0,  0,  0,
			   0,  0,  0,  0};
#define text_x 90
#define text_y 70
#define _text_x text_x/2
#define _text_y text_y/2
unsigned char      speed[text_x];
unsigned char       text[text_x*text_y + text_x];
unsigned char text_light[text_x*text_y + text_x]; //255 - white; 254 - none; 
float         text_depth[text_x*text_y + text_x]; 
//unsigned char        pic[text_x*text_y + text_x]; //Ghostly picture
#include "matrix2.h"
float           bump_pic[text_x*text_y + text_x];
int pic_offset=text_x*text_y*7;
int exit_mode=1;                                  //0 - none; 1 - exit mode (explode main text);
float r1=0.2,r2=1,r3=0.4;
float texture_add=0;
float exit_angle=0;
long timer=40;                                    //main timer;
long one_frame=60;timer2=0,timer3=0,mouse_counter=0;
int mode2=1;
clock_t time1=0;
time_t  time2=0;
int pic_mode=1;                                   //0 - none; 1 - pic fade in; 2 - pic fade out;
int pic_fade=0;
char xvis[40]="xvisual=";

void make_text(void)
{
  long a;
  unsigned int r;
  srand(10);
  for(a=0;a<(text_x*text_y);a++){
    r=rand()&0xFFFF;
    text[a]=r;
  }
  for(a=0;a<text_x;a++) speed[a]=rand()&1;
}


// ------
// Frames per second (FPS) statistic variables and routine.

#define FRAME_RATE_SAMPLES 50
int FrameCount=0;
float FrameRate=0;

void RESET_TIMER()
{
   time(&time2);
}

int TIMER() 
{
   time_t now;
   time(&now);
   if((now-time2)>=30){time2=now;return 1;}
   return 0;
}

void draw_char(long num, float light, float x,float y,float z)
{
   float tx,ty;
   long num2,num3;
   
   num&=63;light=light/255; //light=7-light;num+=(light*60);
   num2=num/10;
   num3=num-(num2*10);
   ty=(float)num2/7;
   tx=(float)num3/10;
   glNormal3f( 0.0f, 0.0f, 1.0f); // Needed for lighting
   glColor4f(0.9,0.4,0.3,light); // Basic polygon color

   glTexCoord2f(tx, ty); glVertex3f( x, y, z); 
   glTexCoord2f(tx+0.1, ty); glVertex3f( x+1, y, z);
   glTexCoord2f(tx+0.1, ty+0.166); glVertex3f( x+1, y-1, z);
   glTexCoord2f(tx, ty+0.166); glVertex3f( x, y-1, z);
}

void draw_char2(long num, float x,float y,float z)
{
   float tx,ty;
   long num2,num3;
   
   num2=num/10;
   num3=num-(num2*10);
   ty=(float)num2/7;
   tx=(float)num3/10;
   glNormal3f( 0.0f, 0.0f, 1.0f); // Needed for lighting
   glColor4f(0.9,0.4,0.3,.5); // Basic polygon color

   glTexCoord2f(tx, ty); glVertex3f( x, y, z); 
   glTexCoord2f(tx+0.1, ty); glVertex3f( x+1, y, z);
   glTexCoord2f(tx+0.1, ty+0.166); glVertex3f( x+1, y-1, z);
   glTexCoord2f(tx, ty+0.166); glVertex3f( x, y-1, z);
}

void draw_char3(float x,float y,float z) //flare
{
   glNormal3f( 0.0f, 0.0f, 1.0f); // Needed for lighting
   glColor4f(0.9,0.4,0.3,.8); // Basic polygon color

   glTexCoord2f(0, 0); glVertex3f( x-1, y+1, z); 
   glTexCoord2f(0.75, 0); glVertex3f( x+2, y+1, z);
   glTexCoord2f(0.75, 0.75); glVertex3f( x+2, y-2, z);
   glTexCoord2f(0, 0.75); glVertex3f( x-1, y-2, z);
}

void draw_text1(void)
{
  float x,y;
  long p=0;
  int c,c_pic;
  if(pic_mode==1){pic_fade++;if(pic_fade>255){pic_fade=255;}}
  if(pic_mode==2){pic_fade--;if(pic_fade<0){pic_fade=0;}}
  for(y=_text_y;y>-_text_y;y--){
  for(x=-_text_x;x<_text_x;x++){
    c=text_light[p]-(text[p]>>1);c+=pic_fade;if(c>255) c=255;                                  //main text
    c_pic=pic[p+pic_offset]-(255-pic_fade); if(c_pic<0) {c_pic=0;} c-=c_pic;if(c<0) {c=0;}   //ghostly picture
    bump_pic[p]=(float)(255-c_pic)/32;
    if(c>10) if(text[p]) draw_char(text[p]+1,c,x,y,text_depth[p]+bump_pic[p]);
//    if(exit_mode) text_depth[p]+=(((float)text[p]-128)/2000);
//             else text_depth[p]/=1.1;
    p++;
  }}
}

void draw_text2(void)
{
  float x,y;
  long p=0;
  for(y=_text_y;y>-_text_y;y--){
  for(x=-_text_x;x<_text_x;x++){
    if(text_light[p]>128) if(text_light[p+text_x]<10) draw_char2(text[p]+1,x,y,text_depth[p]+bump_pic[p]);
    p++;
  }}
}

void draw_text3(void)
{
  float x,y;
  long p=0;
  for(y=_text_y;y>-_text_y;y--){
  for(x=-_text_x;x<_text_x;x++){
    if(text_light[p]>128) if(text_light[p+text_x]<10) draw_char3(x,y,text_depth[p]+bump_pic[p]);
    p++;
  }}
}

void scroll (int mode)  //mode: 0 - normal; 1 - without clone
{
  unsigned int a,s,polovina;
  polovina=(text_x*text_y)/2;s=0;
  for(a=(text_x*text_y)+text_x-1;a>text_x;a--){
      if(speed[s]){     
        text_light[a]=text_light[a-text_x];    //scroll light table down
      }
      s++;if(s>=text_x) s=0;    
  }
  if(timer2&1){
    //====== CHANGING SCENE ======
	if(timer==0)  pic_mode=1;                //pic fade in
	if(timer>110) {mode2=0;mode=0;}
    if(timer>140) {                          //pic fade out   
                   if(timer<145) pic_mode=2;
		  }
    if(timer>280) {timer=-1;                 //back to start + (pic++)
                   //pic_offset+=(text_x*text_y);if(pic_offset>=(text_x*text_y*16)) pic_offset=0;
		   pic_offset=(rand()&15)*(text_x*text_y);}
    timer++;
    //============================
    for(a=(text_x*text_y)+text_x-1;a>text_x;a--){
      text_light[a]=text_light[a-text_x];    //scroll light table down
    }
    for(a=0;a<text_x;a++) text_light[a]=253; //clear top line (in light table)
    s=0;
    for(a=polovina;a<(text_x*text_y);a++){
      if(text_light[a]==255) text_light[s]=text_light[s+text_x]>>1;     //make black bugs in top line
      s++;if(s>=text_x) s=0;
    }
  }
  timer2++;
  if(!mode) glutTimerFunc(one_frame,scroll,mode2);
}

void make_change(void)
{
  unsigned int r=rand()&0xFFFF;
  r>>=3;  
  if(r<(text_x*text_y)) text[r]+=133; //random bugs
  
  r=rand()&0xFFFF;r>>=7;
  if(r<text_x) if(text_light[r]!=0) text_light[r]=255;     //white bugs

  if(mode2) scroll(mode2);
}

// ------
// Routine which actually does the drawing

void cbRenderScene(
   void
)
{  
   glBindTexture(GL_TEXTURE_2D,1);
   glEnable(GL_BLEND);
   glEnable(GL_TEXTURE_2D);

   glDisable(GL_LIGHTING);
   glBlendFunc(GL_SRC_ALPHA,GL_ONE); 
   glDisable(GL_DEPTH_TEST); 
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST_MIPMAP_LINEAR);
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity(); 
   glTranslatef(0.0f,0.0f,Z_Off);

   // Clear the color and depth buffers.
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   if(exit_mode) exit_angle+=0.08;
            else exit_angle/=1.1;
   if(texture_add>0) texture_add/=1.05;
//   glRotatef(exit_angle,r1,r2,r3);

   // OK, let's start drawing our planer quads.
   glBegin(GL_QUADS); 
   draw_text1();
   glEnd();
   
   glBindTexture(GL_TEXTURE_2D,2);
   glBegin(GL_QUADS);
   draw_text2();
   glEnd();
   
   glBindTexture(GL_TEXTURE_2D,3);
   glBegin(GL_QUADS);
   draw_text3(); //flares
   glEnd();
   
   make_change();
   
   glLoadIdentity();
   glMatrixMode(GL_PROJECTION);

   glutSwapBuffers();
}


void MouseFunc(int x, int y)
{
  RESET_TIMER();
  if(mouse_counter>=1) exit(1);
  mouse_counter++;
}

// ------
// Callback function called when a normal key is pressed.

void cbKeyPressed(
   unsigned char key, 
   int x, int y
)
{
   RESET_TIMER();
   switch (key) {
      case 113: case 81: case 27: // Q (Escape) - We're outta here.
      //glutDestroyWindow(Window_ID);
      exit(0);
      break; // exit doesn't return, but anyway...
      
   case 'e':  // e - Explode mode
      exit_mode^=1; 
      break;

/*   case 'p':  // p - Picture mode ON/OFF
      if(pic_mode==2) pic_mode=1; else pic_mode=2;
      break;

   case 'n': // n - Next picture.
      pic_offset+=(text_x*text_y);if(pic_offset>=(text_x*text_y*16)) pic_offset=0; 
      break;
*/
   default:
      printf ("No action for %d.\n", key);
      break;
    }
}


// ------
// Callback Function called when a special key is pressed.

void cbSpecialKeyPressed(
   int key,
   int x, 
   int y
)
{
   RESET_TIMER();
   switch (key) {
   case GLUT_KEY_PAGE_UP: // move the scene into the distance.
      Z_Off -= 0.3f;
      break;

   case GLUT_KEY_PAGE_DOWN: // move the scene closer.
      Z_Off += 0.3f;
      break;

   default:
      printf ("No action for %d.\n", key);
      break;
    }
}


void ourBuildTextures(
   void
)
{
   GLenum gluerr;

   glBindTexture(GL_TEXTURE_2D,1);
   if ((gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA8, 512, 256, GL_GREEN,
                 GL_UNSIGNED_BYTE, (void *)font))) {

      fprintf(stderr,"GLULib%s\n",gluErrorString(gluerr));
      exit(-1);
   }
   glBindTexture(GL_TEXTURE_2D,2);
   if ((gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA8, 512, 256, GL_LUMINANCE,
                 GL_UNSIGNED_BYTE, (void *)font))) {

      fprintf(stderr,"GLULib%s\n",gluErrorString(gluerr));
      exit(-1);
   }
   glBindTexture(GL_TEXTURE_2D,3);
   if ((gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA8, 4, 4, GL_LUMINANCE,
                 GL_UNSIGNED_BYTE, (void *)flare))) {

      fprintf(stderr,"GLULib%s\n",gluErrorString(gluerr));
      exit(-1);
   }

   // Some pretty standard settings for wrapping and filtering.
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

   // We start with GL_DECAL mode.
   glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
}


// ------
// Callback routine executed whenever our window is resized.  Lets us
// request the newly appropriate perspective projection matrix for 
// our needs.  Try removing the gluPerspective() call to see what happens.

void cbResizeScene(
   int Width,
   int Height
)
{
   // Let's not core dump, no matter what.
   if (Height == 0)
      Height = 1;

   glViewport(0, 0, Width, Height);

   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);

   glMatrixMode(GL_MODELVIEW);

   Window_Width  = Width;
   Window_Height = Height;
}


// ------
// Does everything needed before losing control to the main
// OpenGL event loop.  

void ourInit(
  int Width,
  int Height
) 
{
   ourBuildTextures();   

   // Color to clear color buffer to.
   glClearColor(0.0f, 0.0f, 0.0f, 0.0f);

   // Depth to clear depth buffer to; type of test.
   glClearDepth(1.0);
   glDepthFunc(GL_LESS); 

   // Enables Smooth Color Shading; try GL_FLAT for (lack of) fun.
   glShadeModel(GL_SMOOTH);

   // Load up the correct perspective matrix; using a callback directly.
   cbResizeScene(Width,Height);

   // Set up a light, turn it on.
   glLightfv(GL_LIGHT1, GL_POSITION, Light_Position);
   glLightfv(GL_LIGHT1, GL_AMBIENT,  Light_Ambient);
   glLightfv(GL_LIGHT1, GL_DIFFUSE,  Light_Diffuse); 
   glEnable (GL_LIGHT1); 

   // A handy trick -- have surface material mirror the color.
   glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);
   glEnable(GL_COLOR_MATERIAL);
}


void load_texture(void)
{
  long a;
  for(a=0;a<131072;a++){
    if( (a>>9)&2 )  font[a]=font[a];
              else  font[a]=font[a]>>1;
  }
}


#ifndef WIN32_MODE
void screenhack (Window window)
{
  Display *dpy;
  dpy=XOpenDisplay(NULL);
  XMoveResizeWindow(dpy,window,0,0,1,1);
  XCloseDisplay(dpy);
}
#endif


#ifdef WIN32_MODE
int __stdcall WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR lpCmd,int nShow){
   int argc=1;
   load_texture();
   make_text();
   if(lpCmd[1]=='p') exit(0);
   if(lpCmd[1]=='c') exit(0);
   if(FindWindow("GLUT","GLUT")!=NULL) exit(0);
   //MessageBox(0,lpCmd,"command line",MB_OK);
   glutInit(&argc, &lpCmd);
#else
int main(int argc,char **argv){
   char *par;
   int win;
   if(argc>1) {
     par=argv[1];
     if(!strcmp(par,"-window-id")) {
       par=argv[2];
       win=strtol(par,NULL,10);
       printf("%d \n",win);
       screenhack(win);
     }
     if(!strcmp(par,"-install")) {
       system("cp matrix_gl /usr/bin/matrix_gl.kss");
       system("cp KMatrix_gl.desktop /usr/share/applnk/System/ScreenSavers/KMatrix_gl.desktop");
       system("cp KMatrix_gl.desktop /usr/share/applnk-mdk/.hidden/ScreenSavers/KMatrix_gl.desktop");
       printf("Install complete\n");
       exit(0);
     }
     if(!strcmp(par,"-remove")) {
       system("rm /usr/bin/matrix_gl.kss");
       system("rm /usr/share/applnk/System/ScreenSavers/KMatrix_gl.desktop");
       system("rm /usr/share/applnk-mdk/.hidden/ScreenSavers/KMatrix_gl.desktop");
       printf("Uninstall complete\n");
       exit(0);
     }
   }
   
   load_texture();
   make_text();
   glutInit(&argc, argv);
#endif

   // To see OpenGL drawing, take out the GLUT_DOUBLE request.
   glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
   //glutInitWindowSize(Window_Width, Window_Height);

   // Open a window 
   // Window_ID = glutCreateWindow( "matrix_gl" );
   /*glutGameModeString("800x600:8@85");
   if(glutGameModeGet(GLUT_GAME_MODE_WIDTH)==-1) printf("GLUT GAME MODE WIDTH IS NOT CORRECT\n");
   if(glutGameModeGet(GLUT_GAME_MODE_PIXEL_DEPTH)==-1) printf("GLUT GAME MODE PIXEL DEPTH IS NOT CORRECT\n");
   if(glutGameModeGet(GLUT_GAME_MODE_REFRESH_RATE)==-1) printf("GLUT GAME MODE REFRESH RATE IS NOT CORRECT\n");*/
   glutEnterGameMode();

   // Register the callback function to do the drawing. 
   glutDisplayFunc(&cbRenderScene);

   // If there's nothing to do, draw.
   glutIdleFunc(&cbRenderScene);

   // It's a good idea to know when our window's resized.
   glutReshapeFunc(&cbResizeScene);

   // And let's get some keyboard input.
   glutKeyboardFunc(&cbKeyPressed);
   glutSpecialFunc(&cbSpecialKeyPressed);

   glutPassiveMotionFunc(MouseFunc);	

   // OK, OpenGL's ready to go.  Let's call our own init function.
   ourInit(Window_Width, Window_Height);

   // Print out a bit of help dialog.
   printf("\n" PROGRAM_TITLE "\n\n\
Page up/down will move scene away from/towards camera.\n\n\
Author: nightradio@knoppix.ru.\n\
Page:   www.knoppix.ru\n");

   // Pass off control to OpenGL.
   // Above functions are called as appropriate.
   glutMainLoop();

 //glutLeaveGameMode();
   return 0;
}

